let trace v = 
  print_string "Trace: ";
  print_value v;
  print_newline ()
;;

let rec sem_expr:(expr -> econt -> ccont) =
  fun (e:expr) (k:econt) (sigma:state) -> match e with

    | Expr_Num(n) -> k (int_to_value n) sigma

    | _ -> failwith "sem_expr"
;;

let rec sem_com:(prog -> ccont -> ccont) =
  fun (p:prog) (c:ccont) (sigma:state) -> match p with

    | Skip -> c sigma

    | Assign(x,e) ->
	let k v sigma' = c (update sigma' x v)
	in sem_expr e k sigma

    | _ -> failwith "sem_com"


let print_answer l = 
  print_string "Anwser: ";
  begin
    let rec aux =
      function [] -> ()
	| x::l' -> 
	    print_value x; 
	    print_string " ";
	    aux l'
    in aux l
  end;
  print_string "\n"
;;


let go_cont file =
  let prog = parse (file_to_string file) in
    begin
      print_string "\n\n\nDenotational Semantics with Continuations\n";
      print_line ();
      print prog;
      print_line ();
      let (cont0:ccont) = fun (sigma:state) -> [] in
      let ans = sem_com prog cont0 sigma0 in
	print_answer ans
    end
;;

