let file_to_string file =
  let channel = open_in file in
  let rec read acc =
    try
      read (acc^"\n"^(input_line channel))
    with
      | End_of_file -> acc
  in read ""
;;

let parse source = 
  make_prog make_token (Lexing.from_string source)
;;

let print_line () = 
  print_string "------\n"
;;

let print_value v =
  match v with
    | Int(n) -> print_int n
    | _ -> failwith "print_value"
;;

let int_to_value n = Int(n);;

let value_to_int v = 
    match v with
    | Int(n) -> n
    | _ -> failwith "value_to_int"
;;

let value0 = int_to_value 0;;

let binop_value op v w =
  match (v, w) with
    | (Int(n), Int(m)) -> Int(op n m)
    | _ -> failwith "binop_value"
;;

let ccont_to_value c = Ccont(c);;

let value_to_ccont v = 
    match v with
    | Ccont(c) -> c
    | _ -> failwith "value_to_ccont"
;;
